-- Shields
-- RJ 20200819

Shield = class()

function Shield:init(img, pos)
    self.img = img
    self.pos = pos
end

function Shield:draw()
    tint(0,255,0)
    sprite(self.img, self.pos.x, self.pos.y)
end

function createShields()
    local img = readImage(asset.shield)
    local posX = 34
    local posY = 48
    Shields = {}
    for s = 1,4 do
        local entry = Shield(img:copy(), vec2(posX,posY))
        table.insert(Shields,entry)
        posX = posX + 22 + 23
    end
end

function drawShields()
    pushStyle()
    for i,shield in ipairs(Shields) do
        shield:draw()
    end
    popStyle()
end

function Shield:applyDamage(hitPos)
    local relativePos = hitPos - self.pos - vec2(2,3)
    self:clearFromBitmap(relativePos.x, relativePos.y, BombExplosion)
end

function Shield:hitBits(pos,w,h)
    for x = pos.x,pos.x+w-1 do
        for y = pos.y,pos.y+h-1 do
            local has = self:hasBit(x,y)
            if has then return true end
        end
    end
    return false
end

function Shield:hasBit(x,y)
    local xx = x - self.pos.x + 1
    local yy = y - self.pos.y + 1
    if xx < 1 or xx > 22 or yy < 1 or yy > 16 then return false end
    local r,g,b = self.img:get(xx,yy)
    return r + b + g > 0
end

function Shield:clearFromBitmap(tx,ty, source)
    for x = 1,source.width do
        for y = 1,source.height do
            r,g,b = source:get(x,y)
            if r+g+b > 0 then
                self.img:set(tx+x-1, ty+y-1, 0,0,0,0) 
            end
        end
    end
end


